Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Signature
<Highlight
  attribute={string}
  hit={object}
  // Optional props
  highlightedTagName={ReactType}
  nonHighlightedTagName={ReactType}
  separator={ReactNode}
  classNames={object}
  ...props={ComponentProps<'span'>}
/>

Import

JavaScript
import { Highlight } from "react-instantsearch";

See this widget in action

Preview this widget and its behavior.

About this widget

Displays the highlighted attributes of your search results. The required hit prop is an Algolia hit provided by <Hits>, <InfiniteHits> or their Hooks. You can pass a custom object that doesn’t come from Algolia, as long as you follow the expected structure.
JSON
{
  "_highlightResult": {
    "attributeName": {
      "value": "..."
    }
  }
}

Examples

JavaScript
import React from "react";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, Hits, Highlight } from "react-instantsearch";

const searchClient = algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey");

function Hit({ hit }) {
  return (
    <article>
      <h1>
        <Highlight attribute="name" hit={hit} />
      </h1>
      <p>${hit.price}</p>
    </article>
  );
}

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <Hits hitComponent={Hit} />
    </InstantSearch>
  );
}

Props

attribute
keyof THit
required
The highlighted attribute.Specify a dot-separated value for nested objects, like actor.name.
JavaScript
<Highlight
  // ...
  attribute="name"
/>
hit
THit
required
The original hit object provided to the component. It contains all the data for that result, including the highlighted parts.
The hit object must contain a _highlightResult[attribute].value property.
JavaScript
<Highlight
  // ...
  hit={hit}
/>;
highlightedTagName
React.ReactType<any>
default:"mark"
The HTML element that wraps the highlight.
JavaScript
<Highlight
  // ...
  highlightedTagName="em"
/>;
nonHighlightedTagName
React.ReactType<any>
default:"span"
The HTML element that wraps the non-highlighted parts of the string.
JavaScript
<Highlight
  // ...
  nonHighlightedTagName="div"
/>;
separator
React.ReactNode
default:", "
The character between each item when the attribute to highlight is an array.
JavaScript
<Highlight
  // ...
  separator=" - "
/>;
classNames
Partial<HighlightClassNames>
To customize the appearance, override the appropriate class in your widget theme. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.
  • root. The root element of the widget.
  • highlighted. The highlighted parts.
  • nonHighlighted. The non-highlighted parts.
  • separator. The separator elements between highlighted parts.
JavaScript
<Highlight
  // ...
  classNames={{
    root: "MyCustomHighlight",
    separator:
      "MyCustomHighlightSeparator MyCustomHighlightSeparator--subclass",
  }}
/>;
...props
React.ComponentProps<'span'>
Any <span> prop to forward to the root element of the widget.
JavaScript
<Highlight
  // ...
  className="MyCustomHighlight"
  title="My custom title"
/>;
Last modified on May 19, 2026

UI libraries / Angular InstantSearch / Widgets
Signature
<ais-highlight
  attribute="string"
  [hit]="object"
  // Optional parameters
  tagName="string"
></ais-highlight>
Import
1
2
3
4
5
6
7
8
import { NgAisHighlightModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisHighlightModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The Highlight widget renders any attribute from a hit into its highlighted form (when relevant). The hit property is an object as provided by ais-hits and ais-infinite-hits.

This component leverages the highlighting feature of Algolia and is designed to work with escapeHTML set to true in the surrounding <ais-hits></ais-hits>.

Examples

Basic usage

1
<ais-highlight attribute="title" [hit]="hit"></ais-highlight>

Usage with nested properties

Given this record:

1
2
3
4
5
6
{
  "objectID": 1,
  "meta": {
    "title": "my title"
  }
}

You can access the highlighted version by specifying the path separating levels with dots:

1
<ais-highlight attribute="meta.title" [hit]="hit"></ais-highlight>

Usage within hits

1
2
3
4
5
6
7
8
<ais-hits>
  <ng-template let-hits="hits">
    <div *ngFor="let hit of hits">
      Hit {{hit.objectID}}:
      <ais-highlight attribute="title" [hit]="hit"></ais-highlight>
    </div>
  </ng-template>
</ais-hits>

Properties

attribute
type: string
Required

Attribute of the record to highlight. You can give a dot-separated value for deeply nested objects, like actor.name.

1
<ais-highlight attribute="name"></ais-highlight>
hit
type: object
Required

Original “hit” object, given from Hits or connectHits. Needs a _highlightResult[attribute].value to work.

1
<ais-highlight [hit]="hit"></ais-highlight>
tagName
type: string
default: "em"
Optional

Tag to use for the highlighted parts of the string. For example: mark.

1
<ais-highlight tagName="mark"></ais-highlight>

HTML output

1
<span class="ais-Highlight">This is the <em class="ais-Highlight-highlighted">highlighted text</em></span>
Did you find this page helpful?